org.apache.tapestry5.json

## Class JSONObject

- java.lang.Object
- - org.apache.tapestry5.json.JSONCollection
  - - org.apache.tapestry5.json.JSONObject

- All Implemented Interfaces:
    java.io.Serializable

      public final class JSONObject
      extends JSONCollection

  A modifiable set of name/value mappings. Names are unique, non-null strings. Values may be any mix of `JSONObjects`, `JSONArrays`, Strings, Booleans, Integers, Longs, Doubles or `NULL`. Values may not be `null`, `NaNs`, `infinities`, or of any type not listed here.

  This class can coerce values to another type when requested.

  - When the requested type is a boolean, strings will be coerced using a case-insensitive comparison to "true" and "false".
  - When the requested type is a double, other `Number` types will be coerced using `doubleValue`. Strings that can be coerced using `Double.valueOf(String)` will be.
  - When the requested type is an int, other `Number` types will be coerced using `intValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to int.
  - When the requested type is a long, other `Number` types will be coerced using `longValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to long. This two-step conversion is lossy for very large values. For example, the string "9223372036854775806" yields the long 9223372036854775807.
  - When the requested type is a String, other non-null values will be coerced using `String.valueOf(Object)`. Although null cannot be coerced, the sentinel value `NULL` is coerced to the string "null".

  This class can look up both mandatory and optional values:

  - Use `getType()` to retrieve a mandatory value. This fails with a `RuntimeException` if the requested name has no value or if the value cannot be coerced to the requested type.
  - Use `opt()` to retrieve an optional value.

  Warning: this class represents null in two incompatible ways: the standard Java `null` reference, and the sentinel value `NULL`. In particular, calling `put(name, null)` removes the named entry from the object but `put(name, JSONObject.NULL)` stores an entry whose value is `JSONObject.NULL`.

  Instances of this class are not thread safe.

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.Object` | `NULL` A sentinel value used to explicitly define a name with no value.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JSONObject()` Creates a `JSONObject` with no name/value mappings.
    `JSONObject(JSONObject copyFrom, java.lang.String... names)` Creates a new `JSONObject` by copying mappings for the listed names from the given object.
    `JSONObject(java.lang.Object... keysAndValues)` Constructs a new JSONObject using a series of String keys and object values.
    `JSONObject(java.lang.String json)` Creates a new `JSONObject` with name/value mappings from the JSON string.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `JSONObject` | `accumulate(java.lang.String name, java.lang.Object value)` Appends `value` to the array already mapped to `name`.
    `JSONObject` | `append(java.lang.String name, java.lang.Object value)` Appends values to the array mapped to `name`.
    `JSONObject` | `copy()` Returns a new JSONObject that is a shallow copy of this JSONObject.
    `boolean` | `equals(java.lang.Object obj)`
    `java.lang.Object` | `get(java.lang.String name)` Returns the value mapped by `name`, or throws if no such mapping exists.
    `boolean` | `getBoolean(java.lang.String name)` Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.
    `double` | `getDouble(java.lang.String name)` Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.
    `int` | `getInt(java.lang.String name)` Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.
    `JSONArray` | `getJSONArray(java.lang.String name)` Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.
    `JSONObject` | `getJSONObject(java.lang.String name)` Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.
    `long` | `getLong(java.lang.String name)` Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise.
    `java.lang.String` | `getString(java.lang.String name)` Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.
    `boolean` | `has(java.lang.String name)` Returns true if this object has a mapping for `name`.
    `JSONObject` | `in(java.lang.String key)` Navigates into a nested JSONObject, creating the JSONObject if necessary.
    `boolean` | `isNull(java.lang.String name)` Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.
    `java.util.Set<java.lang.String>` | `keys()` Returns the set of `String` names in this object.
    `int` | `length()` Returns the number of name/value mappings in this object.
    `JSONArray` | `names()` Returns an array containing the string names in this object.
    `static java.lang.String` | `numberToString(java.lang.Number number)` Encodes the number as a JSON string.
    `java.lang.Object` | `opt(java.lang.String name)` Returns the value mapped by `name`, or null if no such mapping exists.
    `JSONObject` | `put(java.lang.String name, java.lang.Object value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
    `JSONObject` | `putAll(java.util.Map<java.lang.String,?> newProperties)` Invokes `put(String, Object)` for each value from the map.
    `static java.lang.String` | `quote(java.lang.String data)` Encodes `data` as a JSON string.
    `java.lang.Object` | `remove(java.lang.String name)` Removes the named mapping if it exists; does nothing otherwise.
    `java.util.Map<java.lang.String,java.lang.Object>` | `toMap()` Returns a Map of the keys and values of the JSONObject.

    - ### Methods inherited from class org.apache.tapestry5.json.JSONCollection

      `prettyPrint, print, print, toCompactString, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### NULL

          public static final java.lang.Object NULL

      A sentinel value used to explicitly define a name with no value. Unlike `null`, names with this value:
      - show up in the `names()` array
      - show up in the `keys()` iterator
      - return `true` for `has(String)`
      - do not throw on `get(String)`
      - are included in the encoded JSON string.

      This value violates the general contract of `Object.equals(java.lang.Object)` by returning true when compared to `null`. Its `JSONCollection.toString()` method returns "null".

  - ### Constructor Detail

    - #### JSONObject

          public JSONObject()

      Creates a `JSONObject` with no name/value mappings.

    - #### JSONObject

          public JSONObject(java.lang.String json)

      Creates a new `JSONObject` with name/value mappings from the JSON string.
      Parameters:
        `json` - a JSON-encoded string containing an object.
      Throws:
        `java.lang.RuntimeException` - if the parse fails or doesn't yield a `JSONObject`.

    - #### JSONObject

          public JSONObject(JSONObject copyFrom,
                            java.lang.String... names)

      Creates a new `JSONObject` by copying mappings for the listed names from the given object. Names that aren't present in `copyFrom` will be skipped.
      Parameters:
        `copyFrom` - The source object.
        `names` - The names of the fields to copy.
      Throws:
        `java.lang.RuntimeException` - On internal errors. Shouldn't happen.

    - #### JSONObject

          public JSONObject(java.lang.Object... keysAndValues)

      Constructs a new JSONObject using a series of String keys and object values. Object values sholuld be compatible with `put(String, Object)`. Keys must be strings (toString() will be invoked on each key). Prior to release 5.4, keysAndValues was type String...; changing it to Object... makes it much easier to initialize a JSONObject in a single statement, which is more readable.
      Since:
        5.2.0

  - ### Method Detail

    - #### copy

          public JSONObject copy()

      Returns a new JSONObject that is a shallow copy of this JSONObject.
      Since:
        5.4

    - #### length

          public int length()

      Returns the number of name/value mappings in this object.
      Returns:
        the length of this.

    - #### put

          public JSONObject put(java.lang.String name,
                                java.lang.Object value)

      Maps `name` to `value`, clobbering any existing name/value mapping with the same name. If the value is `null`, any existing mapping for `name` is removed.
      Parameters:
        `name` - The name of the new value.
        `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL`, or `null`. May not be `NaNs` or `infinities`.
      Returns:
        this object.
      Throws:
        `java.lang.RuntimeException` - if the value is an invalid double (infinite or NaN).

    - #### accumulate

          public JSONObject accumulate(java.lang.String name,
                                       java.lang.Object value)

      Appends `value` to the array already mapped to `name`. If this object has no mapping for `name`, this inserts a new mapping. If the mapping exists but its value is not an array, the existing and new values are inserted in order into a new array which is itself mapped to `name`. In aggregate, this allows values to be added to a mapping one at a time. Note that `append(String, Object)` provides better semantics. In particular, the mapping for `name` will always be a `JSONArray`. Using `accumulate` will result in either a `JSONArray` or a mapping whose type is the type of `value` depending on the number of calls to it.
      Parameters:
        `name` - The name of the field to change.
        `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL` or null. May not be `NaNs` or `infinities`.
      Returns:
        this object after mutation.
      Throws:
        `java.lang.RuntimeException` - If the object being added is an invalid number.

    - #### append

          public JSONObject append(java.lang.String name,
                                   java.lang.Object value)

      Appends values to the array mapped to `name`. A new `JSONArray` mapping for `name` will be inserted if no mapping exists. If the existing mapping for `name` is not a `JSONArray`, a `RuntimeException` will be thrown.
      Parameters:
        `name` - The name of the array to which the value should be appended.
        `value` - The value to append.
      Returns:
        this object.
      Throws:
        `java.lang.RuntimeException` - if `name` is `null` or if the mapping for `name` is non-null and is not a `JSONArray`.

    - #### remove

          public java.lang.Object remove(java.lang.String name)

      Removes the named mapping if it exists; does nothing otherwise.
      Parameters:
        `name` - The name of the mapping to remove.
      Returns:
        the value previously mapped by `name`, or null if there was no such mapping.

    - #### isNull

          public boolean isNull(java.lang.String name)

      Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.
      Parameters:
        `name` - The name of the value to check on.
      Returns:
        true if the field doesn't exist or is null.

    - #### has

          public boolean has(java.lang.String name)

      Returns true if this object has a mapping for `name`. The mapping may be `NULL`.
      Parameters:
        `name` - The name of the value to check on.
      Returns:
        true if this object has a field named `name`

    - #### get

          public java.lang.Object get(java.lang.String name)

      Returns the value mapped by `name`, or throws if no such mapping exists.
      Parameters:
        `name` - The name of the value to get.
      Returns:
        The value.
      Throws:
        `java.lang.RuntimeException` - if no such mapping exists.

    - #### opt

          public java.lang.Object opt(java.lang.String name)

      Returns the value mapped by `name`, or null if no such mapping exists.
      Parameters:
        `name` - The name of the value to get.
      Returns:
        The value.

    - #### getBoolean

          public boolean getBoolean(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or cannot be coerced to a boolean.

    - #### getDouble

          public double getDouble(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or cannot be coerced to a double.

    - #### getInt

          public int getInt(java.lang.String name)

      Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The selected value if it exists.
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or cannot be coerced to an int.

    - #### getLong

          public long getLong(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise. Note that JSON represents numbers as doubles, so this is lossy; use strings to transfer numbers via JSON without loss.
      Parameters:
        `name` - The name of the field that we want.
      Returns:
        The value of the field.
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or cannot be coerced to a long.

    - #### getString

          public java.lang.String getString(java.lang.String name)

      Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.
      Parameters:
        `name` - The name of the field we want.
      Returns:
        The value of the field.
      Throws:
        `java.lang.RuntimeException` - if no such mapping exists.

    - #### getJSONArray

          public JSONArray getJSONArray(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.
      Parameters:
        `name` - The field we want to get.
      Returns:
        The value of the field (if it is a JSONArray.
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or is not a `JSONArray`.

    - #### getJSONObject

          public JSONObject getJSONObject(java.lang.String name)

      Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.
      Parameters:
        `name` - The name of the field that we want.
      Returns:
        a specified field value (if it is a JSONObject)
      Throws:
        `java.lang.RuntimeException` - if the mapping doesn't exist or is not a `JSONObject`.

    - #### keys

          public java.util.Set<java.lang.String> keys()

      Returns the set of `String` names in this object. The returned set is a view of the keys in this object. `Set.remove(Object)` will remove the corresponding mapping from this object and set iterator behaviour is undefined if this object is modified after it is returned. See `keys()`.
      Returns:
        The names in this object.

    - #### names

          public JSONArray names()

      Returns an array containing the string names in this object. This method returns null if this object contains no mappings.
      Returns:
        the names.

    - #### numberToString

          public static java.lang.String numberToString(java.lang.Number number)

      Encodes the number as a JSON string.
      Parameters:
        `number` - a finite value. May not be `NaNs` or `infinities`.
      Returns:
        The encoded number in string form.
      Throws:
        `java.lang.RuntimeException` - On internal errors. Shouldn't happen.

    - #### quote

          public static java.lang.String quote(java.lang.String data)

      Encodes `data` as a JSON string. This applies quotes and any necessary character escaping.
      Parameters:
        `data` - the string to encode. Null will be interpreted as an empty string.
      Returns:
        the quoted string.

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### toMap

          public java.util.Map<java.lang.String,java.lang.Object> toMap()

      Returns a Map of the keys and values of the JSONObject. The returned map is unmodifiable. Note that changes to the JSONObject will be reflected in the map. In addition, null values in the JSONObject are represented as `NULL` in the map.
      Returns:
        unmodifiable map of properties and values
      Since:
        5.4

    - #### putAll

          public JSONObject putAll(java.util.Map<java.lang.String,?> newProperties)

      Invokes `put(String, Object)` for each value from the map.
      Parameters:
        `newProperties` - to add to this JSONObject
      Returns:
        this JSONObject
      Since:
        5.4

    - #### in

          public JSONObject in(java.lang.String key)

      Navigates into a nested JSONObject, creating the JSONObject if necessary. They key must not exist, or must be a JSONObject.
      Parameters:
        `key` -
      Returns:
        the nested JSONObject
      Throws:
        `java.lang.IllegalStateException` - if the current value for the key is not null and not JSONObject

${project.version} - Copyright © 2003-2015 The Apache Software Foundation.